import { keymap as cmView_keymap } from '@codemirror/view'
import { forward_decorations as cm_forward_decorations, attach_BANG_ as cm_attach_BANG_ } from './../codemirror.mjs'
import { configure_BANG_ as language_configure_BANG_ } from './../codemirror/language.mjs'
import { arrow_handler as blankKeymap_arrow_handler } from './../plugins/keymap.mjs'
import { get, zero_QMARK_, partial, assoc_BANG_, update, conj, constantly } from 'squint-cljs/core.js'
import { EditorState, EditorSelection, Compartment, Prec } from '@codemirror/state';
import { EditorView } from '@codemirror/view';
import { TextSelection, Selection, NodeSelection } from 'prosemirror-state';
import { undo, redo } from 'prosemirror-history';
import { GapCursor } from 'prosemirror-gapcursor';
var maybe_escape = function (unit, dir, p__55, cm_view, _event) {
let map__5657 = p__55;
let node58 = get(map__5657, "node");
let view59 = get(map__5657, "view");
let get_pos60 = get(map__5657, "get-pos");
let state62 = cm_view["state"];
let map__6163 = cm_view["state"]["selection"];
let main64 = get(map__6163, "main");
if (blankKeymap_arrow_handler(dir, view59["state"], view59["dispatch"])) {
view59.focus();
return true;} else {
if (!main64["empty"]) {
return false;} else {
let main65 = (("line" === unit)) ? (state62["doc"].lineAt(main64["head"])) : (main64);
if ((main65 && (((0 < dir) && (main65["to"] < state62["doc"]["length"])) || ((dir < 0) && (0 < main65["from"]))))) {
return false;} else {
let target_pos66 = (function () {
 let G__6768 = get_pos60();
if ((0 < dir)) {
return (G__6768 + node58["nodeSize"]);} else {
return G__6768;}
})();
let $target_pos69 = view59["state"]["doc"].resolve(target_pos66);
let goal_column70 = (("line" === unit)) ? (((0 < dir)) ? ((state62["selection"]["main"]["to"] - main65["from"])) : ((main65["to"] - state62["selection"]["main"]["to"]))) : (null);
let selection71 = (GapCursor.valid($target_pos69)) ? (new GapCursor($target_pos69)) : (Selection.near((goal_column70) ? (view59["state"]["doc"].resolve(((0 < dir)) ? (Math.min(($target_pos69["pos"] + goal_column70), $target_pos69.end())) : (Math.max(($target_pos69["pos"] - goal_column70), $target_pos69.start())))) : ($target_pos69), dir));
view59.dispatch(view59["state"]["tr"].setSelection(selection71).scrollIntoView());
view59.focus();
return true;}}}
}
;
var maybe_delete = function (p__72, cm_view, _event) {
let map__7374 = p__72;
let get_pos75 = get(map__7374, "get-pos");
let view76 = get(map__7374, "view");
let node77 = get(map__7374, "node");
let sel78 = cm_view["state"]["selection"]["main"];
if ((sel78["empty"] && zero_QMARK_(sel78["from"]) && zero_QMARK_(cm_view["state"]["doc"]["length"]))) {
let from79 = get_pos75();
let $pos80 = view76["state"]["doc"].resolve((function () {
 let G__8182 = from79;
if ((0 < from79)) {
return (G__8182 - 1);} else {
return G__8182;}
})());
view76.dispatch(view76["state"]["tr"].setSelection((GapCursor.valid($pos80)) ? (new GapCursor($pos80)) : (Selection.near($pos80, -1))).delete(from79, (from79 + node77["nodeSize"])));
view76.focus();
return true;}
}
;
var select_node = function (p__83, cm_view, _event) {
let map__8485 = p__83;
let get_pos86 = get(map__8485, "get-pos");
let view87 = get(map__8485, "view");
if (cm_view["state"]["selection"]["main"]["empty"]) {
view87.dispatch(view87["state"]["tr"].setSelection(new NodeSelection(view87["state"]["doc"].resolve(get_pos86()))));
return true;}
}
;
var keymap = function (p__88) {
let map__8990 = p__88;
let parent_view91 = map__8990;
let view92 = get(map__8990, "view");
return [({ "key": "Backspace", "run": partial(maybe_delete, parent_view91) }), ({ "key": "Escape", "run": partial(select_node, parent_view91) }), ({ "key": "ArrowUp", "run": partial(maybe_escape, "line", -1, parent_view91) }), ({ "key": "ArrowDown", "run": partial(maybe_escape, "line", 1, parent_view91) }), ({ "key": "ArrowLeft", "run": partial(maybe_escape, "char", -1, parent_view91) }), ({ "key": "ArrowRight", "run": partial(maybe_escape, "char", 1, parent_view91) }), ({ "key": "Mod-z", "run": function () {
return undo(get(view92, "state"), get(view92, "dispatch"));
} }), ({ "key": "Shift-Mod-z", "run": function () {
return redo(get(view92, "state"), get(view92, "dispatch"));
} })];
}
;
var pm__GT_cm_selection = function (p__93, max_len) {
let map__9495 = p__93;
let view96 = get(map__9495, "view");
let get_pos97 = get(map__9495, "get-pos");
let map__9899 = view96["state"]["selection"];
let anchor100 = get(map__9899, "anchor");
let head101 = get(map__9899, "head");
let offset102 = (get_pos97() + 1);
return EditorSelection.single(Math.min((anchor100 - offset102), max_len), Math.min((head101 - offset102), max_len));
}
;
var view_update = function (p__103, _surrounding_decorations, inner_decorations) {
let map__104105 = p__103;
let node106 = map__104105;
let textContent107 = get(map__104105, "textContent");
let this108 = this;
if ((this108["node"]["type"]["name"] === node106["type"]["name"])) {
assoc_BANG_(this108, "node", node106);
let map__109110 = this108;
let updating111 = get(map__109110, "updating");
let cm112 = get(map__109110, "cm");
let get_pos113 = get(map__109110, "get-pos");
if ((updating111 || (textContent107 === cm112["state"]["doc"].toString()))) {
null} else {
assoc_BANG_(this108, "updating", true);
cm112.dispatch(({ "changes": ({ "from": 0, "to": cm112["state"]["doc"]["length"], "insert": textContent107 }), "selection": pm__GT_cm_selection(this108, textContent107["length"]) }));
assoc_BANG_(this108, "updating", false)};
if ((inner_decorations && inner_decorations["find"])) {
cm112.dispatch(({ "effects": cm_forward_decorations.of(({ "pm-decorations": inner_decorations.find() })) }))};
return true;}
}
;
var view_destroy = function () {
let this114 = this;
this114["cm"].destroy();
return true;
}
;
var view_set_selection = function (anchor, head) {
let this115 = this;
this115["cm"].focus();
assoc_BANG_(this115, "updating", true);
this115["cm"].dispatch(({ "selection": ({ "head": head, "anchor": anchor }) }));
return assoc_BANG_(this115, "updating", false);
}
;
var view_deselect_node = function () {
let this116 = this;
return this116["dom"]["classList"].remove("ProseMirror-selectednode");
}
;
var CodeView = function (node, view, get_pos, opts) {
let this117 = this;
assoc_BANG_(this117, "node", node, "view", view, "get-pos", get_pos);
let dom118 = (function () {
 let G__119120 = document.createElement("div");
assoc_BANG_(G__119120, "classList", "viewer-code mb-5");
return G__119120;
})();
return language_configure_BANG_(assoc_BANG_(cm_attach_BANG_(this117, dom118, update(opts, "extensions", conj, Prec.high(cmView_keymap.of(keymap(this117))))), "updating", false, "dom", dom118, "update", view_update, "destroy", view_destroy, "stopEvent", constantly(true), "ignoreMutation", constantly(true), "setSelection", view_set_selection, "deselectNode", view_deselect_node), opts);
}
;
var view = function (opts) {
return function (node, view, get_pos) {
return new CodeView(node, view, get_pos, opts);
};
}
;

export { view_update, view_deselect_node, maybe_escape, keymap, view_set_selection, view_destroy, CodeView, select_node, pm__GT_cm_selection, view, maybe_delete }
