import {  } from 'katex'
import { attach_BANG_ as cm_attach_BANG_ } from './../codemirror.mjs'
import { key as blankEditSignal_key } from './../plugins/edit_signal.mjs'
import {  } from './../plugins/keymap.mjs'
import { conj, get, assoc_BANG_, some, update, partial, str, count, assoc, constantly } from 'squint-cljs/core.js'
import { keymap } from '@codemirror/view';
import { NodeSelection } from 'prosemirror-state';
import katex from 'katex';
var inline_QMARK_ = function (this$) {
return ("inline_formula" === this$["node"]["type"]["name"]);
}
;
var render_latex_BANG_ = function (this$) {
let latex32 = this$["node"]["textContent"];
katex.render(((0 < count(latex32))) ? (latex32) : ("Empty"), this$["katexDom"], ({ "throwOnError": false, "displayMode": !inline_QMARK_(this$), "output": "html" }));
return this$;
}
;
var show_popover = function (this$) {
this$["popoverDom"]["classList"].remove("hidden");
this$["cm"].focus();
return assoc_BANG_(this$, "editing", true);
}
;
var hide_popover = function (this$) {
this$["popoverDom"]["classList"].add("hidden");
return assoc_BANG_(this$, "editing", false);
}
;
var toggle_popover_BANG_ = function (this$) {
if (this$["editing"]) {
hide_popover(this$)} else {
show_popover(this$)};
return this$;
}
;
var view_update = function (node, decorations, _) {
let this33 = this;
assoc_BANG_(this33, "node", node);
if (some(function (_PERCENT_1) {
return (blankEditSignal_key === _PERCENT_1["spec"]["key"]);
}, decorations)) {
show_popover(this33)} else {
render_latex_BANG_(this33)};
return true;
}
;
var view_set_selection = function (anchor, head) {
console.log("formula/set-selection", anchor, head);
let this34 = this;
return true;
}
;
var handle_escape = function (p__35, _, _36) {
let map__3738 = p__35;
let parent_view39 = map__3738;
let view40 = get(map__3738, "view");
let get_pos41 = get(map__3738, "get-pos");
hide_popover(parent_view39);
view40.dispatch(view40["state"]["tr"].setSelection(NodeSelection.create(view40["state"]["doc"], get_pos41())));
view40.focus();
return true;
}
;
var editor_keymap = function (this$) {
return [({ "key": "Escape", "run": partial(handle_escape, this$) })];
}
;
var FormulaView = function (node, view, get_pos, opts) {
let this42 = this;
assoc_BANG_(this42, "node", node, "view", view, "get-pos", get_pos);
let katex_dom43 = (function () {
 let G__4445 = document.createElement("div");
G__4445.setAttribute("style", "min-height: 1rem;");
return G__4445;
})();
let cm_dom46 = (function () {
 let G__4748 = document.createElement("div");
assoc_BANG_(G__4748, "classList", "viewer-code opacity-75");
return G__4748;
})();
let popover_dom49 = (function () {
 let G__5051 = document.createElement("div");
assoc_BANG_(G__5051, "classList", "block border border-blue-200 hidden");
G__5051.appendChild(cm_dom46);
G__5051.setAttribute("style", str("transform: translateX(-50%) translateY(-110%);", "width: 600px;", "left: 50%; z-index: 991;"));
return G__5051;
})();
let dom52 = (function () {
 let G__5354 = document.createElement("div");
assoc_BANG_(G__5354, "classList", str("relative ", (inline_QMARK_(this42)) ? ("inline-block") : (null)));
G__5354.appendChild(popover_dom49);
G__5354.appendChild(katex_dom43);
return G__5354;
})();
katex_dom43.addEventListener("click", function () {
return toggle_popover_BANG_(this42);
});
return render_latex_BANG_(assoc_BANG_(cm_attach_BANG_(this42, cm_dom46, update(assoc(opts, "placeholder", "Write some latex..."), "extensions", conj, keymap.of(editor_keymap(this42)))), "editing", false, "updating", false, "katexDom", katex_dom43, "popoverDom", popover_dom49, "dom", dom52, "update", view_update, "setSelection", view_set_selection, "destroy", constantly(true), "stopEvent", constantly(true), "ignoreMutation", constantly(true), "stopEvent", constantly(true)));
}
;
var view = function (opts) {
return function (node, view, get_pos) {
return new FormulaView(node, view, get_pos, opts);
};
}
;

export { editor_keymap, view_update, toggle_popover_BANG_, render_latex_BANG_, view_set_selection, handle_escape, inline_QMARK_, show_popover, hide_popover, view, FormulaView }
