import { get, partial, contains_QMARK_, set } from 'squint-cljs/core.js'
import { Plugin, NodeSelection, Selection } from 'prosemirror-state';
import { DecorationSet, Decoration } from 'prosemirror-view';
var range_selection_to_json = function (this$) {
return ({ "type": "range", "anchor": this$["anchor"], "head": this$["head"] });
}
;
var range_selection_eq = function (this$, other) {
return ((other instanceof RangeSelection) && (other["anchor"] === this$["anchor"]) && (other["head"] === this$["head"]));
}
;
var range_selection_map = function (this$, doc, mapping) {
let $anchor159 = doc.resolve(mapping.map(this$["$anchor"]["pos"]));
let $head160 = doc.resolve(mapping.map(this$["$head"]["pos"]));
if (($head160["parent"]["inlineContent"] && $anchor159["parent"]["inlineContent"])) {
return new pm-state/TextSelection($anchor159, $head160);} else {
return new RangeSelection($anchor159, $head160);}
}
;
var RangeSelection = function ($anchor, $head, ranges) {
let target161 = new Selection($anchor, $head, ranges);
let this162 = this;
return new Proxy(this162, ({ "get": function (this$, prop, receiver) {
if (Reflect.has(target161, prop)) {
return get(target161, prop);} else {
let G__163164 = prop;
switch (G__163164) {case "toJSON":
return partial(range_selection_to_json, target161);
break;
case "eq":
return partial(range_selection_eq, target161);
break;
case "map":
return partial(range_selection_map, target161);
break;
default:
return console.warn("method-missing", prop);}}
} }));
}
;
var selectable_QMARK_ = function (node) {
return contains_QMARK_(set(["code", "formula"]), node["type"]["name"]);
}
;
var selected_node_decoration = function (from, to) {
return Decoration.node(from, to, ({ "class": "ProseMirror-selectednode" }));
}
;
var decorations = function (state) {
if ((!(state["selection"] instanceof NodeSelection) && !state["selection"]["empty"])) {
let decorations166 = [];
state["doc"].nodesBetween(state["selection"]["from"], state["selection"]["to"], function (node, pos) {
if (selectable_QMARK_(node)) {
decorations166.push(selected_node_decoration(pos, (pos + node["nodeSize"])))};
return false;
});
return DecorationSet.create(get(state, "doc"), decorations166);} else {
return DecorationSet["empty"];}
}
;
var plugin = new Plugin(({ "props": ({ "decorations": decorations }) }))
;

export { range_selection_to_json, range_selection_eq, range_selection_map, RangeSelection, selectable_QMARK_, selected_node_decoration, decorations, plugin }
