import { Decoration as cm_view_Decoration } from '@codemirror/view'
import { forward_decorations as blank_cm_forward_decorations } from './../codemirror.mjs'
import { Doc as Y_Doc } from 'yjs'
import { get, assoc_BANG_, constantly, some, nil_QMARK_, keep, str } from 'squint-cljs/core.js'
import { StateField, StateEffect, EditorState } from '@codemirror/state';
import { EditorView, WidgetType } from '@codemirror/view';
import { Plugin, PluginKey } from 'prosemirror-state';
import { Decoration, DecorationSet } from 'prosemirror-view';
import { WebsocketProvider } from 'y-websocket';
import { absolutePositionToRelativePosition, relativePositionToAbsolutePosition, ySyncPlugin, ySyncPluginKey, yCursorPlugin, setMeta, defaultCursorBuilder, defaultSelectionBuilder } from 'y-prosemirror';
var key = new PluginKey("blank.collab")
;
var RemoteCursor = function (p__233) {
let map__234235 = p__233;
let user236 = get(map__234235, "user");
let key237 = get(map__234235, "key");
let this238 = this;
return assoc_BANG_(this238, "key", key237, "compare", function (other) {
return (key237 === other["key"]);
}, "eq", function (other) {
return (key237 === other["key"]);
}, "updateDOM", constantly(true), "destroy", function () {
return null;
}, "toDOM", function (view) {
return defaultCursorBuilder(user236);
});
}
;
var pm__GT_cm_deco = function (p__239) {
let map__240241 = p__239;
let from242 = get(map__240241, "from");
let to243 = get(map__240241, "to");
let spec244 = get(map__240241, "spec");
let map__245246 = spec244;
let key247 = get(map__245246, "key");
let user248 = get(map__245246, "user");
if ((key247 && user248)) {
return cm_view_Decoration.widget(({ "widget": new RemoteCursor(spec244), "key": key247 })).range(from242, to243);} else {
return null;}
}
;
var cm_cursor_state = StateField.define(({ "provide": function (field) {
return EditorView["decorations"].from(field);
}, "create": function (_state) {
return cm_view_Decoration["none"];
}, "update": function (decos, p__249) {
let map__250251 = p__249;
let _tr252 = map__250251;
let effects253 = get(map__250251, "effects");
let temp__24820__auto__254 = some(function (_PERCENT_1) {
if (_PERCENT_1.is(blank_cm_forward_decorations)) {
return _PERCENT_1["value"];}
}, effects253);
if (nil_QMARK_(temp__24820__auto__254)) {
return decos;} else {
let map__255256 = temp__24820__auto__254;
let pm_decorations257 = get(map__255256, "pm-decorations");
return cm_view_Decoration.set(keep(pm__GT_cm_deco, pm_decorations257));}
} }))
;
var names = ["Bean", "Luci", "Elfo", "Zøg", "Ursula", "Oona", "Dagmar", "Pendergast", "Odval", "Merkimer"]
;
var colors = ["#fed7aa", "#bef264", "#a7f3d0", "#67e8f9", "#0891b2", "#bfdbfe", "#f0abfc", "#fda4af", "#f43f5e", "#fde68a"]
;
var rand_nth = function (a) {
return get(a, Math.trunc((a["length"] * Math.random())));
}
;
var init_state = function (p__258) {
let map__259260 = p__258;
let doc_name261 = get(map__259260, "doc-name", "blank");
let host262 = get(map__259260, "host", "localhost");
let port263 = get(map__259260, "port", 1234);
let name264 = get(map__259260, "name", rand_nth(names));
let color265 = get(map__259260, "color", rand_nth(colors));
let y_doc266 = new Y_Doc();
let y_ws267 = new WebsocketProvider(str("ws://", host262, ":", port263), doc_name261, y_doc266);
let y_awareness268 = (function () {
 let G__269270 = y_ws267["awareness"];
G__269270.setLocalStateField("user", ({ "name": name264, "color": color265 }));
return G__269270;
})();
let y_xml_fragment271 = y_doc266.getXmlFragment("prosemirror");
return ({ "awareness": y_awareness268, "plugins": [ySyncPlugin(y_xml_fragment271), yCursorPlugin(y_awareness268)] });
}
;

export { key, RemoteCursor, pm__GT_cm_deco, cm_cursor_state, names, colors, rand_nth, init_state }
