import { key as editSignal_key } from './edit_signal.mjs'
import { contains_QMARK_, set, get, nil_QMARK_, neg_QMARK_, assoc, partial } from 'squint-cljs/core.js'
import { baseKeymap } from 'prosemirror-commands';
import { GapCursor } from 'prosemirror-gapcursor';
import { undo, redo } from 'prosemirror-history';
import { splitListItem, sinkListItem, liftListItem } from 'prosemirror-schema-list';
import { NodeSelection, Selection, TextSelection } from 'prosemirror-state';
import { RangeSelection } from './blockwise_selection.mjs';
var is_opaque_block_QMARK_ = function (node) {
return contains_QMARK_(set(["code", "formula"]), node["type"]["name"]);
}
;
var list_item_QMARK_ = function (node) {
return contains_QMARK_(set(["list_item", "todo_item"]), node["type"]["name"]);
}
;
var list_item_type = function (pos) {
let d167 = pos["depth"];
while(true){
if ((d167 < 0)) {
return null;} else {
let node168 = pos.node(d167);
if (list_item_QMARK_(node168)) {
return node168["type"];} else {
let G__169 = (d167 - 1);
d167 = G__169;
continue;
}};break;
}

}
;
var base_enter_handler = get(baseKeymap, "Enter")
;
var maybe_enter_node_edit_mode = function (state, dispatch) {
let map__170171 = state["selection"];
let sel172 = map__170171;
let from173 = get(map__170171, "from");
let to174 = get(map__170171, "to");
let temp__25021__auto__175 = ((sel172 instanceof NodeSelection)) ? (sel172["node"]) : (null);
if (nil_QMARK_(temp__25021__auto__175)) {
return null;} else {
let node176 = temp__25021__auto__175;
if (contains_QMARK_(set(["formula", "inline_formula", "code"]), node176["type"]["name"])) {
dispatch(state["tr"].setSelection(TextSelection.create(state["doc"], from173)).setMeta(editSignal_key, ({ "from": from173, "to": to174, "action": "edit" })));
return true;}}
}
;
var maybe_split_list_handler = function (p__177, dispatch, view) {
let map__178179 = p__177;
let state180 = map__178179;
let selection181 = get(map__178179, "selection");
if (selection181["empty"]) {
null};
let temp__25021__auto__182 = list_item_type(selection181["$head"]);
if (nil_QMARK_(temp__25021__auto__182)) {
return null;} else {
let item_type183 = temp__25021__auto__182;
return splitListItem(item_type183)(state180, dispatch, view);}
}
;
var enter_handler = function (state, dispatch, view) {
return (maybe_enter_node_edit_mode(state, dispatch) || maybe_split_list_handler(state, dispatch, view) || base_enter_handler(state, dispatch, view));
}
;
var sink_list_item_handler = function (state, dispatch, view) {
let temp__24820__auto__184 = list_item_type(state["selection"]["$head"]);
if (nil_QMARK_(temp__24820__auto__184)) {
return null;} else {
let item_type185 = temp__24820__auto__184;
return sinkListItem(item_type185)(state, dispatch, view);}
}
;
var lift_list_item_handler = function (state, dispatch, view) {
let temp__24820__auto__186 = list_item_type(state["selection"]["$head"]);
if (nil_QMARK_(temp__24820__auto__186)) {
return null;} else {
let item_type187 = temp__24820__auto__186;
return liftListItem(item_type187)(state, dispatch, view);}
}
;
var next_node = function ($pos, side) {
if ((side < 0)) {
return $pos["nodeBefore"];} else {
return $pos["nodeAfter"];}
}
;
var leaves_text_block_QMARK_ = function (p__188, dir) {
let map__189190 = p__188;
let view191 = map__189190;
let state192 = get(map__189190, "state");
return (view191 && state192["selection"]["empty"] && view191.endOfTextblock(dir));
}
;
var arrow_handler = function (dir, p__193, dispatch, view) {
let map__194195 = p__193;
let state196 = map__194195;
let doc197 = get(map__194195, "doc");
let selection198 = get(map__194195, "selection");
if ((leaves_text_block_QMARK_(view, dir) || (selection198 instanceof GapCursor) || (state196["selection"] instanceof NodeSelection))) {
let side199 = ((("up" === dir) || ("left" === dir))) ? (-1) : (1);
let $pos200 = (leaves_text_block_QMARK_(view, dir)) ? (doc197.resolve(((0 < side199)) ? (selection198["$head"].after(1)) : (selection198["$head"].before(1)))) : (((0 < side199)) ? (selection198["$head"]) : (selection198["$anchor"]));
let temp__25021__auto__201 = next_node($pos200, side199);
if (nil_QMARK_(temp__25021__auto__201)) {
return null;} else {
let adjacent_node202 = temp__25021__auto__201;
if (((state196["selection"] instanceof NodeSelection) || ("formula" === adjacent_node202["type"]["name"]))) {
let from203 = (function () {
 let G__204205 = $pos200["pos"];
if ((side199 < 0)) {
return (G__204205 - adjacent_node202["nodeSize"]);} else {
return G__204205;}
})();
dispatch(state196["tr"].setSelection(NodeSelection.create(doc197, from203)).scrollIntoView());
if (view) {
view.focus()};
return true;} else {
if (("code" === adjacent_node202["type"]["name"])) {
dispatch(state196["tr"].setSelection(Selection.near($pos200, side199)));
return true;} else {
return null;}}}}
}
;
var maybe_toggle_node_selection_handler = function (p__206, dispatch) {
let map__207208 = p__206;
let state209 = map__207208;
let doc210 = get(map__207208, "doc");
let tr211 = get(map__207208, "tr");
let selection212 = get(map__207208, "selection");
if ((selection212 instanceof NodeSelection)) {
return dispatch(tr211.setSelection(Selection.near(selection212["$anchor"])).scrollIntoView());} else {
if (selection212["empty"]) {
if (NodeSelection.isSelectable(selection212["$head"].node(1))) {
dispatch(tr211.setSelection(NodeSelection.create(doc210, selection212["$head"].before(1))).scrollIntoView());
return true;}} else {
return null;}}
}
;
var next_pos_after_head = function (p__213, side) {
let map__214215 = p__213;
let sel216 = map__214215;
let $head217 = get(map__214215, "$head");
let depth218 = ((sel216 instanceof TextSelection)) ? (sel216["depth"]) : (1);
if ((side < 0)) {
return $head217.before(depth218);} else {
return $head217.after(depth218);}
}
;
var range_sel_head = function (sel, doc, side) {
if ((side < 0)) {
if (sel["$head"]["parent"]["inlineContent"]) {
return sel["$head"];} else {
let temp__24900__auto__219 = sel["$head"]["nodeBefore"];
if (temp__24900__auto__219) {
let node_before220 = temp__24900__auto__219;
return doc.resolve((sel["$head"]["pos"] - node_before220["nodeSize"]));}}} else {
return sel["$head"];}
}
;
var text_sel_head = function (sel, doc, side) {
if ((side < 0)) {
return sel["$head"];} else {
let temp__24900__auto__221 = next_node(sel["$head"], side);
if (temp__24900__auto__221) {
let sel_node222 = temp__24900__auto__221;
return doc.resolve((sel["$head"]["pos"] + sel_node222["nodeSize"]));}}
}
;
var shift_arrow_handler = function (dir, state, dispatch, view) {
let side223 = (contains_QMARK_(new Set(["left", "up"]), dir)) ? (-1) : (1);
let sel224 = state["selection"];
let doc225 = state["doc"];
if ((view.endOfTextblock(dir) || (sel224 instanceof RangeSelection) || (sel224 instanceof GapCursor))) {
let $next_pos226 = state["doc"].resolve(next_pos_after_head(sel224, side223));
let new_head_sel227 = Selection.near($next_pos226, side223);
let temp__24900__auto__228 = next_node($next_pos226, side223);
if (temp__24900__auto__228) {
let node229 = temp__24900__auto__228;
let new_sel230 = (is_opaque_block_QMARK_(node229)) ? ((function () {
 let $head231 = (range_sel_head(new_head_sel227, doc225, side223) || sel224["$head"]);
let $head232 = (is_opaque_block_QMARK_($head231["parent"])) ? ((neg_QMARK_(side223)) ? (doc225.resolve($head231.before())) : (doc225.resolve($head231.after()))) : ($head231);
return new RangeSelection(sel224["$anchor"], $head232);
})()) : (new TextSelection(sel224["$anchor"], (text_sel_head(new_head_sel227, doc225, side223) || sel224["$head"])));
if (((sel224 instanceof TextSelection) && (new_sel230 instanceof TextSelection))) {
return null;} else {
dispatch(state["tr"].setSelection(new_sel230));
return true;}}}
}
;
var keymap = assoc(baseKeymap, "Enter", enter_handler, "Escape", maybe_toggle_node_selection_handler, "Mod-]", sink_list_item_handler, "Mod-[", lift_list_item_handler, "ArrowUp", partial(arrow_handler, "up"), "ArrowDown", partial(arrow_handler, "down"), "ArrowLeft", partial(arrow_handler, "left"), "ArrowRight", partial(arrow_handler, "right"), "Shift-ArrowUp", partial(shift_arrow_handler, "up"), "Shift-ArrowDown", partial(shift_arrow_handler, "down"), "Shift-ArrowLeft", partial(shift_arrow_handler, "left"), "Shift-ArrowRight", partial(shift_arrow_handler, "right"), "Mod-z", undo, "Shift-Mod-z", redo)
;

export { list_item_QMARK_, shift_arrow_handler, keymap, range_sel_head, sink_list_item_handler, maybe_split_list_handler, maybe_toggle_node_selection_handler, leaves_text_block_QMARK_, next_node, base_enter_handler, arrow_handler, list_item_type, enter_handler, is_opaque_block_QMARK_, lift_list_item_handler, maybe_enter_node_edit_mode, next_pos_after_head, text_sel_head }
